"""
@generated by mypy-protobuf.  Do not edit manually!
isort:skip_file
"""
import builtins
import typing

import SiLAFramework_pb2
import google.protobuf.descriptor
import google.protobuf.internal.containers
import google.protobuf.message
import typing_extensions

DESCRIPTOR: google.protobuf.descriptor.FileDescriptor = ...

# Parameters for GetFeatureDefinition

class GetFeatureDefinition_Parameters(google.protobuf.message.Message):
    DESCRIPTOR: google.protobuf.descriptor.Descriptor = ...
    FEATUREIDENTIFIER_FIELD_NUMBER: builtins.int
    #
    # The fully qualified Feature identifier for which the Feature definition shall be retrieved.
    @property
    def FeatureIdentifier(self) -> SiLAFramework_pb2.String: ...
    def __init__(
        self,
        *,
        FeatureIdentifier: typing.Optional[SiLAFramework_pb2.String] = ...,
    ) -> None: ...
    def HasField(
        self, field_name: typing_extensions.Literal["FeatureIdentifier", b"FeatureIdentifier"]
    ) -> builtins.bool: ...
    def ClearField(self, field_name: typing_extensions.Literal["FeatureIdentifier", b"FeatureIdentifier"]) -> None: ...

global___GetFeatureDefinition_Parameters = GetFeatureDefinition_Parameters

# Responses of GetFeatureDefinition

class GetFeatureDefinition_Responses(google.protobuf.message.Message):
    DESCRIPTOR: google.protobuf.descriptor.Descriptor = ...
    FEATUREDEFINITION_FIELD_NUMBER: builtins.int
    # The Feature definition in XML format (according to the Feature Definition Schema).
    @property
    def FeatureDefinition(self) -> SiLAFramework_pb2.String: ...
    def __init__(
        self,
        *,
        FeatureDefinition: typing.Optional[SiLAFramework_pb2.String] = ...,
    ) -> None: ...
    def HasField(
        self, field_name: typing_extensions.Literal["FeatureDefinition", b"FeatureDefinition"]
    ) -> builtins.bool: ...
    def ClearField(self, field_name: typing_extensions.Literal["FeatureDefinition", b"FeatureDefinition"]) -> None: ...

global___GetFeatureDefinition_Responses = GetFeatureDefinition_Responses

# Parameters for SetServerName

class SetServerName_Parameters(google.protobuf.message.Message):
    DESCRIPTOR: google.protobuf.descriptor.Descriptor = ...
    SERVERNAME_FIELD_NUMBER: builtins.int
    # The human readable name to assign to the SiLA Server.
    @property
    def ServerName(self) -> SiLAFramework_pb2.String: ...
    def __init__(
        self,
        *,
        ServerName: typing.Optional[SiLAFramework_pb2.String] = ...,
    ) -> None: ...
    def HasField(self, field_name: typing_extensions.Literal["ServerName", b"ServerName"]) -> builtins.bool: ...
    def ClearField(self, field_name: typing_extensions.Literal["ServerName", b"ServerName"]) -> None: ...

global___SetServerName_Parameters = SetServerName_Parameters

# Responses of SetServerName

class SetServerName_Responses(google.protobuf.message.Message):
    DESCRIPTOR: google.protobuf.descriptor.Descriptor = ...
    def __init__(
        self,
    ) -> None: ...

global___SetServerName_Responses = SetServerName_Responses

# Parameters for ServerName
class Get_ServerName_Parameters(google.protobuf.message.Message):
    DESCRIPTOR: google.protobuf.descriptor.Descriptor = ...
    def __init__(
        self,
    ) -> None: ...

global___Get_ServerName_Parameters = Get_ServerName_Parameters

# Responses of ServerName

class Get_ServerName_Responses(google.protobuf.message.Message):
    DESCRIPTOR: google.protobuf.descriptor.Descriptor = ...
    SERVERNAME_FIELD_NUMBER: builtins.int
    #
    # Human readable name of the SiLA Server. The name can be set using the 'Set Server Name' command.
    @property
    def ServerName(self) -> SiLAFramework_pb2.String: ...
    def __init__(
        self,
        *,
        ServerName: typing.Optional[SiLAFramework_pb2.String] = ...,
    ) -> None: ...
    def HasField(self, field_name: typing_extensions.Literal["ServerName", b"ServerName"]) -> builtins.bool: ...
    def ClearField(self, field_name: typing_extensions.Literal["ServerName", b"ServerName"]) -> None: ...

global___Get_ServerName_Responses = Get_ServerName_Responses

# Parameters for ServerType
class Get_ServerType_Parameters(google.protobuf.message.Message):
    DESCRIPTOR: google.protobuf.descriptor.Descriptor = ...
    def __init__(
        self,
    ) -> None: ...

global___Get_ServerType_Parameters = Get_ServerType_Parameters

# Responses of ServerType

class Get_ServerType_Responses(google.protobuf.message.Message):
    DESCRIPTOR: google.protobuf.descriptor.Descriptor = ...
    SERVERTYPE_FIELD_NUMBER: builtins.int
    #
    # The type of this server. It, could be, e.g., in the case of a SiLA Device the model name.
    # It is specified by the implementer of the SiLA Server and MAY not be unique.
    @property
    def ServerType(self) -> SiLAFramework_pb2.String: ...
    def __init__(
        self,
        *,
        ServerType: typing.Optional[SiLAFramework_pb2.String] = ...,
    ) -> None: ...
    def HasField(self, field_name: typing_extensions.Literal["ServerType", b"ServerType"]) -> builtins.bool: ...
    def ClearField(self, field_name: typing_extensions.Literal["ServerType", b"ServerType"]) -> None: ...

global___Get_ServerType_Responses = Get_ServerType_Responses

# Parameters for ServerUUID
class Get_ServerUUID_Parameters(google.protobuf.message.Message):
    DESCRIPTOR: google.protobuf.descriptor.Descriptor = ...
    def __init__(
        self,
    ) -> None: ...

global___Get_ServerUUID_Parameters = Get_ServerUUID_Parameters

# Responses of ServerUUID

class Get_ServerUUID_Responses(google.protobuf.message.Message):
    DESCRIPTOR: google.protobuf.descriptor.Descriptor = ...
    SERVERUUID_FIELD_NUMBER: builtins.int
    #
    # Globally unique identifier that identifies a SiLA Server. The Server UUID MUST be generated once
    # and remain the same for all times.
    @property
    def ServerUUID(self) -> SiLAFramework_pb2.String: ...
    def __init__(
        self,
        *,
        ServerUUID: typing.Optional[SiLAFramework_pb2.String] = ...,
    ) -> None: ...
    def HasField(self, field_name: typing_extensions.Literal["ServerUUID", b"ServerUUID"]) -> builtins.bool: ...
    def ClearField(self, field_name: typing_extensions.Literal["ServerUUID", b"ServerUUID"]) -> None: ...

global___Get_ServerUUID_Responses = Get_ServerUUID_Responses

# Parameters for ServerDescription
class Get_ServerDescription_Parameters(google.protobuf.message.Message):
    DESCRIPTOR: google.protobuf.descriptor.Descriptor = ...
    def __init__(
        self,
    ) -> None: ...

global___Get_ServerDescription_Parameters = Get_ServerDescription_Parameters

# Responses of ServerDescription

class Get_ServerDescription_Responses(google.protobuf.message.Message):
    DESCRIPTOR: google.protobuf.descriptor.Descriptor = ...
    SERVERDESCRIPTION_FIELD_NUMBER: builtins.int
    #
    # Description of the SiLA Server. This should include the use and purpose of this SiLA Server.
    @property
    def ServerDescription(self) -> SiLAFramework_pb2.String: ...
    def __init__(
        self,
        *,
        ServerDescription: typing.Optional[SiLAFramework_pb2.String] = ...,
    ) -> None: ...
    def HasField(
        self, field_name: typing_extensions.Literal["ServerDescription", b"ServerDescription"]
    ) -> builtins.bool: ...
    def ClearField(self, field_name: typing_extensions.Literal["ServerDescription", b"ServerDescription"]) -> None: ...

global___Get_ServerDescription_Responses = Get_ServerDescription_Responses

# Parameters for ServerVersion
class Get_ServerVersion_Parameters(google.protobuf.message.Message):
    DESCRIPTOR: google.protobuf.descriptor.Descriptor = ...
    def __init__(
        self,
    ) -> None: ...

global___Get_ServerVersion_Parameters = Get_ServerVersion_Parameters

# Responses of ServerVersion

class Get_ServerVersion_Responses(google.protobuf.message.Message):
    DESCRIPTOR: google.protobuf.descriptor.Descriptor = ...
    SERVERVERSION_FIELD_NUMBER: builtins.int
    #
    # Returns the version of the SiLA Server. A "Major" and a "Minor" version number (e.g. 1.0) MUST be provided,
    # a Patch version number MAY be provided. Optionally, an arbitrary text, separated by an underscore MAY be
    # appended, e.g. “3.19.373_mighty_lab_devices”.
    @property
    def ServerVersion(self) -> SiLAFramework_pb2.String: ...
    def __init__(
        self,
        *,
        ServerVersion: typing.Optional[SiLAFramework_pb2.String] = ...,
    ) -> None: ...
    def HasField(self, field_name: typing_extensions.Literal["ServerVersion", b"ServerVersion"]) -> builtins.bool: ...
    def ClearField(self, field_name: typing_extensions.Literal["ServerVersion", b"ServerVersion"]) -> None: ...

global___Get_ServerVersion_Responses = Get_ServerVersion_Responses

# Parameters for ServerVendorURL
class Get_ServerVendorURL_Parameters(google.protobuf.message.Message):
    DESCRIPTOR: google.protobuf.descriptor.Descriptor = ...
    def __init__(
        self,
    ) -> None: ...

global___Get_ServerVendorURL_Parameters = Get_ServerVendorURL_Parameters

# Responses of ServerVendorURL

class Get_ServerVendorURL_Responses(google.protobuf.message.Message):
    DESCRIPTOR: google.protobuf.descriptor.Descriptor = ...
    SERVERVENDORURL_FIELD_NUMBER: builtins.int
    #
    # Returns the URL to the website of the vendor or the website of the product of this SiLA Server.
    # This URL SHOULD be accessible at all times.
    # The URL is a Uniform Resource Locator as defined in RFC 1738.
    @property
    def ServerVendorURL(self) -> SiLAFramework_pb2.String: ...
    def __init__(
        self,
        *,
        ServerVendorURL: typing.Optional[SiLAFramework_pb2.String] = ...,
    ) -> None: ...
    def HasField(
        self, field_name: typing_extensions.Literal["ServerVendorURL", b"ServerVendorURL"]
    ) -> builtins.bool: ...
    def ClearField(self, field_name: typing_extensions.Literal["ServerVendorURL", b"ServerVendorURL"]) -> None: ...

global___Get_ServerVendorURL_Responses = Get_ServerVendorURL_Responses

# Parameters for ImplementedFeatures
class Get_ImplementedFeatures_Parameters(google.protobuf.message.Message):
    DESCRIPTOR: google.protobuf.descriptor.Descriptor = ...
    def __init__(
        self,
    ) -> None: ...

global___Get_ImplementedFeatures_Parameters = Get_ImplementedFeatures_Parameters

# Responses of ImplementedFeatures

class Get_ImplementedFeatures_Responses(google.protobuf.message.Message):
    DESCRIPTOR: google.protobuf.descriptor.Descriptor = ...
    IMPLEMENTEDFEATURES_FIELD_NUMBER: builtins.int
    #
    # Returns a list of fully qualified Feature identifiers of all implemented Features of this SiLA Server.
    # This list SHOULD remain the same throughout the lifetime of the SiLA Server.
    @property
    def ImplementedFeatures(
        self,
    ) -> google.protobuf.internal.containers.RepeatedCompositeFieldContainer[SiLAFramework_pb2.String]: ...
    def __init__(
        self,
        *,
        ImplementedFeatures: typing.Optional[typing.Iterable[SiLAFramework_pb2.String]] = ...,
    ) -> None: ...
    def ClearField(
        self, field_name: typing_extensions.Literal["ImplementedFeatures", b"ImplementedFeatures"]
    ) -> None: ...

global___Get_ImplementedFeatures_Responses = Get_ImplementedFeatures_Responses
